package cn.com.qmth.examcloud.core.oe.student.dao.entity;

import cn.com.qmth.examcloud.core.oe.student.dao.enums.ExamCaptureQueueStatus;
import cn.com.qmth.examcloud.web.jpa.WithIdJpaEntity;

import javax.persistence.*;

/**
 * @Description 照片抓拍队列
 * @Author lideyin
 * @Date 2019/12/10 14:00
 * @Version 1.0
 */
@Entity
@Table(name = "ec_oet_exam_capture_queue", indexes = {
        @Index(name = "IDX_E_O_E_C_Q_001", columnList = "examRecordDataId,fileName", unique = true),
        @Index(name = "IDX_E_O_E_C_Q_002", columnList = "status,errorNum")
})
public class ExamCaptureQueueEntity extends WithIdJpaEntity {

    /**
     *
     */
    private static final long serialVersionUID = 4094671807731989565L;

    private Long studentId;

    /**
     * ec_oe_exam_record_data  ID
     */
    private Long examRecordDataId;


    /**
     * 底照Token
     */
    private String baseFaceToken;

    /**
     * 文件URL
     */
    private String fileUrl;

    /**
     * 文件名称
     */
    private String fileName;

    /**
     * 状态
     */
    @Enumerated(EnumType.STRING)
    private ExamCaptureQueueStatus status;

    /**
     * 错误信息
     */
    private String errorMsg;

    /**
     * 错误次数
     */
    private Integer errorNum;

    /**
     * 是否存在虚拟摄像头
     */
    @Column(name = "has_virtual_camera")
    private Boolean hasVirtualCamera;

    /**
     * 摄像头信息  json字符串数组
     */
    @Column(name = "camera_infos", length = 800)
    private String cameraInfos;

    /**
     * 其他信息
     * Json格式
     * {
     * "":""
     * }
     */
    @Column(name = "ext_msg", length = 800)
    private String extMsg;

    /**
     * 队列处理批次号(用户判断某一条数据处理状态)
     */
    private String processBatchNum;

    /**
     * 队列处理的优先级,默认值为0
     */
    private int priority = 0;

    /**
     * 是否有陌生人
     * 就是摄像头拍到不止考生一人
     */
    @Column(name = "is_stranger")
    private Boolean isStranger;

    /**
     * 比较是否通过
     */
    @Column(name = "is_pass")
    private Boolean isPass;

    /**
     * 人脸比较返回信息
     */
    @Column(name = "face_compare_result", length = 2000)
    private String faceCompareResult;

    /**
     * 人脸比对开始时间
     */
    private Long faceCompareStartTime;

    /**
     * 百度在线活体检测结果
     */
    @Column(name = "faceliveness_result", length = 2000)
    private String facelivenessResult;

    public Long getExamRecordDataId() {
        return examRecordDataId;
    }

    public void setExamRecordDataId(Long examRecordDataId) {
        this.examRecordDataId = examRecordDataId;
    }

    public String getFileUrl() {
        return fileUrl;
    }

    public void setFileUrl(String fileUrl) {
        this.fileUrl = fileUrl;
    }

    public ExamCaptureQueueStatus getStatus() {
        return status;
    }

    public void setStatus(ExamCaptureQueueStatus status) {
        this.status = status;
    }

    public String getErrorMsg() {
        return errorMsg;
    }

    public void setErrorMsg(String errorMsg) {
        this.errorMsg = errorMsg;
    }

    public String getBaseFaceToken() {
        return baseFaceToken;
    }

    public void setBaseFaceToken(String baseFaceToken) {
        this.baseFaceToken = baseFaceToken;
    }

    public String getFileName() {
        return fileName;
    }

    public void setFileName(String fileName) {
        this.fileName = fileName;
    }

    public Integer getErrorNum() {
        return errorNum;
    }

    public void setErrorNum(Integer errorNum) {
        this.errorNum = errorNum;
    }

    public Long getStudentId() {
        return studentId;
    }

    public void setStudentId(Long studentId) {
        this.studentId = studentId;
    }

    public Boolean getHasVirtualCamera() {
        return hasVirtualCamera;
    }

    public void setHasVirtualCamera(Boolean hasVirtualCamera) {
        this.hasVirtualCamera = hasVirtualCamera;
    }

    public String getCameraInfos() {
        return cameraInfos;
    }

    public void setCameraInfos(String cameraInfos) {
        this.cameraInfos = cameraInfos;
    }

    public String getExtMsg() {
        return extMsg;
    }

    public void setExtMsg(String extMsg) {
        this.extMsg = extMsg;
    }

    public String getProcessBatchNum() {
        return processBatchNum;
    }

    public void setProcessBatchNum(String processBatchNum) {
        this.processBatchNum = processBatchNum;
    }

    public int getPriority() {
        return priority;
    }

    public void setPriority(int priority) {
        this.priority = priority;
    }

    public Boolean getIsStranger() {
        return isStranger;
    }

    public void setIsStranger(Boolean stranger) {
        isStranger = stranger;
    }

    public Boolean getIsPass() {
        return isPass;
    }

    public void setIsPass(Boolean pass) {
        isPass = pass;
    }

    public String getFaceCompareResult() {
        return faceCompareResult;
    }

    public void setFaceCompareResult(String faceCompareResult) {
        this.faceCompareResult = faceCompareResult;
    }

    public Long getFaceCompareStartTime() {
        return faceCompareStartTime;
    }

    public void setFaceCompareStartTime(Long faceCompareStartTime) {
        this.faceCompareStartTime = faceCompareStartTime;
    }

    public String getFacelivenessResult() {
        return facelivenessResult;
    }

    public void setFacelivenessResult(String facelivenessResult) {
        this.facelivenessResult = facelivenessResult;
    }

}
